﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.Reporting;
using System.ComponentModel;
using System.Threading;
using Infragistics.Windows.DataPresenter;
using System.Collections.ObjectModel;
using IGDocumentation;
using System.Windows.Media.Animation;



namespace Printing
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            Thread thread = new Thread(new ParameterizedThreadStart(DoWork));
            thread.SetApartmentState(ApartmentState.STA);
            thread.IsBackground = true;

            PrintHelp ph = new PrintHelp();
            ph.Data = (this.Resources["CarData"] as ObjectDataProvider).Data as ObservableCollection<Car>;
            ph.Settings = xamDataGrid1.SaveCustomizations();

            thread.Start(ph);
        }

        void DoWork(object info)
        {
            Report reportObj = new Report();
            reportObj.PageHeaderTemplate = this.Resources["PageHeaderTemplate"] as DataTemplate;
            reportObj.PageHeader = "Test Report";
            reportObj.ReportSettings.Margin = new Thickness(50, 50, 50, 50);

            XamDataGrid xdg = new XamDataGrid();
            xdg.DataSource = (info as PrintHelp).Data;            
            xdg.LoadCustomizations((info as PrintHelp).Settings);
            xdg.BeginInit();
            xdg.EndInit();
            EmbeddedVisualReportSection section = new EmbeddedVisualReportSection(xdg);

            reportObj.Sections.Add(section);
            XamReportPreview previewer = new XamReportPreview();
            previewer.GeneratePreview(reportObj, false, false);
            Window window = new Window();
            window.Title = "Previewer test";
            window.Content = previewer;
            window.ShowDialog();
        }
    }

    public class PrintHelp
    {
        public string Settings { get; set; }
        public ObservableCollection<Car> Data { get; set; }
    }
}
